# Complete project details at https://RandomNerdTutorials.com
# Adaptation framboise314.fr
# Attention la LED répond à GRB  ou VERT-ROUGE-BLEU

import wifimgr
from time import sleep
import machine
import time
from apa106 import APA106

rgb_led = machine.Pin(8, machine.Pin.OUT)
ap = APA106(rgb_led, 1)
ap[0] = (0, 128, 0) # Allumer LED Rouge => attente de connexion
ap.write()
time.sleep(0.5)


try:
  import usocket as socket
except:
  import socket

led = machine.Pin(2, machine.Pin.OUT)

wlan = wifimgr.get_connection()
if wlan is None:
    print("Could not initialize the network connection.")
    while True:
        pass  # you shall not pass :D

# Main Code goes here, wlan is a working network.WLAN(STA_IF) instance.
print("ESP OK")
ap[0] = (0, 0, 0) # Eteindre la LED Rouge => Connecté
ap.write()

def web_page():
  if led.value() == 1:
    gpio_state="ON"
  else:
    gpio_state="OFF"
  
  html = """<html>
    <head>
        <title>Serveur Web ESP</title>
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="icon" href="data:,">
        <style>
            html{font-family: Helvetica; display:inline-block; margin: 0px auto; text-align: center;}
            h1{color: #FF0000; padding: 2vh;}p{font-size: 1.5rem;}
            .button{display: inline-block; background-color: #e7bd3b; border: none;
            border-radius: 4px; color: grey; padding: 16px 40px; text-decoration: none; font-size: 30px; margin: 2px; cursor: pointer;}
            .button2{background-color: #00FF00;}
            .button3{background-color: #0000FF;}
            .button4{background-color: #00FFFF;}
            .button5{background-color: #FF00FF;}
            .button6{background-color: #FFFF00;}
            .button7{background-color: #FFFFFF; border:1px solid black;}
            .button8{background-color: #151515;}
        </style>

    </head>
    <body> <h1>Serveur Web ESP</h1>
        <p><strong> Couleur de la LED </strong>
        </p><p><a href="/?led=R"><button class="button">Rouge</button></a></p>
        <p><a href="/?led=V"><button class="button button2">Vert</button></a></p>
        <p><a href="/?led=B"><button class="button button3">Bleu</button></a></p>
        <p><a href="/?led=C"><button class="button button4">CYAN</button></a></p>
        <p><a href="/?led=M"><button class="button button5">MAJ.</button></a></p>
        <p><a href="/?led=J"><button class="button button6">JAUNE</button></a></p>
        <p><a href="/?led=Bl"><button class="button button7">BLANC</button></a></p>
        <p><a href="/?led=N"><button class="button button8">ETEINT</button></a></p>
    </body>
</html>"""
  return html
  
try:
  s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
  s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
  s.bind(('', 80))
  s.listen(5)
except OSError as e:
  machine.reset()

while True:
  try:
    if gc.mem_free() < 102000:
      gc.collect()
    conn, addr = s.accept()
    conn.settimeout(3.0)
    print('Got a connection from %s' % str(addr))
    request = conn.recv(1024)
    conn.settimeout(None)
    request = str(request)
    print('Content = %s' % request)
    led_R = request.find('/?led=R')
    led_V = request.find('/?led=V')
    led_B = request.find('/?led=B')
    led_C = request.find('/?led=C')
    led_M = request.find('/?led=M')
    led_J = request.find('/?led=J')
    led_Bl = request.find('/?led=Bl')
    led_N = request.find('/?led=N')
    if led_R == 6:
      print('LED ROUGE')
      ap[0] = (0, 128, 0) # Allumer LED rouge
      ap.write()
    if led_V == 6:
      print('LED VERTE')
      ap[0] = (128, 0, 0) # Eteindre LED verte
      ap.write()
    if led_B == 6:
      print('LED BLEUE')
      ap[0] = (0, 0, 128) # Allumer LED bleue
      ap.write()
    if led_C == 6:
      print('LED CYAN')
      ap[0] = (128, 0, 128) # Allumer LED cyan
      ap.write()
    if led_M == 6:
      print('LED MAGENTA')
      ap[0] = (0, 128, 128) # Allumer LED magenta
      ap.write()
    if led_J == 6:
      print('LED JAUNE')
      ap[0] = (128, 128, 0) # Allumer LED jaune
      ap.write()
    if led_Bl == 6:
      print('LED BLANCHE')
      ap[0] = (128, 128, 128) # Allumer LED blanche
      ap.write()
    if led_N == 6:
      print('LED ETEINTE')
      ap[0] = (0, 0, 0) # Eteindre la LED
      ap.write()
    response = web_page()
    conn.send('HTTP/1.1 200 OK\n')
    conn.send('Content-Type: text/html\n')
    conn.send('Connection: close\n\n')
    conn.sendall(response)
    conn.close()
  except OSError as e:
    conn.close()
    print('Connection closed')


